'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _reactBootstrap = require('react-bootstrap');

var _reactCmf = require('react-cmf');

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var ButtonAction = function (_React$Component) {
  _inherits(ButtonAction, _React$Component);

  function ButtonAction(props) {
    _classCallCheck(this, ButtonAction);

    var _this = _possibleConstructorReturn(this, (ButtonAction.__proto__ || Object.getPrototypeOf(ButtonAction)).call(this, props));

    _this.onClick = _this.onClick.bind(_this);
    return _this;
  }

  _createClass(ButtonAction, [{
    key: 'onClick',
    value: function onClick(event) {
      if (this.props.onClick) {
        this.props.onClick(event, this.props, this.context);
      }
    }
  }, {
    key: 'render',
    value: function render() {
      var btn = this.props.btn || 'default';
      var label = this.props.label;
      var action = this.props.action;
      var icon = void 0;
      if (action) {
        if (typeof action === 'string') {
          action = _reactCmf.api.action.getActionInfo(this.context, action);
        }
        label = action.name;
        if (this.props.icon) {
          icon = action.icon;
        }
      }
      return _react2.default.createElement(
        _reactBootstrap.Button,
        { bsStyle: btn, onClick: this.onClick },
        icon ? _react2.default.createElement(_reactCmf.Icon, { name: icon, className: 'fa fa-fw' }) : null,
        this.props.hideLabel ? null : label
      );
    }
  }]);

  return ButtonAction;
}(_react2.default.Component);

exports.default = ButtonAction;


ButtonAction.propTypes = Object.assign({
  children: _react2.default.PropTypes.node,
  className: _react2.default.PropTypes.string,
  disabled: _react2.default.PropTypes.bool,
  icon: _react2.default.PropTypes.bool,
  onMouseLeave: _react2.default.PropTypes.func,
  onMouseUp: _react2.default.PropTypes.func,
  btn: _react2.default.PropTypes.string
}, {
  action: _react2.default.PropTypes.oneOfType([_react2.default.PropTypes.string, _react2.default.PropTypes.object]),
  model: _react2.default.PropTypes.object,
  onClick: _react2.default.PropTypes.func,
  hideLabel: _react2.default.PropTypes.bool,
  icon: _react2.default.PropTypes.bool
});
ButtonAction.contextTypes = {
  router: _react2.default.PropTypes.object,
  store: _react2.default.PropTypes.object,
  registry: _react2.default.PropTypes.object
};