'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _classnames = require('classnames');

var _classnames2 = _interopRequireDefault(_classnames);

var _reactCmf = require('react-cmf');

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

/**
 * This component show an action creator and dispatch it to redux
 * The action prop must be something like this:

```javascript
{
  "id":"streams",
  "name":"My streams",
  "creator":"myactions.send", // REQURIED, it must be registred
}
```

 */

var LinkAction = function (_React$Component) {
  _inherits(LinkAction, _React$Component);

  function LinkAction(props) {
    _classCallCheck(this, LinkAction);

    var _this = _possibleConstructorReturn(this, (LinkAction.__proto__ || Object.getPrototypeOf(LinkAction)).call(this, props));

    _this.onClick = _this.onClick.bind(_this);
    return _this;
  }

  _createClass(LinkAction, [{
    key: 'onClick',
    value: function onClick(event) {
      if (this.props.onClick) {
        this.props.onClick(event, this.props, this.context);
      }
    }
  }, {
    key: 'render',
    value: function render() {
      var linkCSS = (0, _classnames2.default)('btn btn-link', this.props.className);
      var _props = this.props;
      var action = _props.action;
      var icon = _props.icon;

      var label = void 0;
      if (action) {
        if (typeof action === 'string') {
          action = _reactCmf.api.action.getActionInfo(this.context, action);
        }
        label = action.name;
        if (icon) {
          icon = action.icon;
        }
      }
      return _react2.default.createElement(
        'a',
        { className: linkCSS, onClick: this.onClick },
        icon ? _react2.default.createElement(_reactCmf.Icon, { name: icon, className: 'fa-fw' }) : null,
        label
      );
    }
  }]);

  return LinkAction;
}(_react2.default.Component);

exports.default = LinkAction;

LinkAction.propTypes = {
  action: _react2.default.PropTypes.oneOfType([_react2.default.PropTypes.string, _react2.default.PropTypes.object]),
  icon: _react2.default.PropTypes.bool,
  model: _react2.default.PropTypes.object,
  displayMode: _react2.default.PropTypes.string,
  onClick: _react2.default.PropTypes.func,

  active: _react2.default.PropTypes.bool,
  count: _react2.default.PropTypes.number,

  className: _react2.default.PropTypes.oneOfType([_react2.default.PropTypes.string, _react2.default.PropTypes.object])
};
LinkAction.contextTypes = {
  router: _react2.default.PropTypes.object,
  store: _react2.default.PropTypes.object,
  registry: _react2.default.PropTypes.object
};